; you may predefine some paras	; last update 30.07.2010

ifndef LOOP_COUNT
	LOOP_COUNT = 1000000
endif

ifndef counter_begin
	include \masm32\macros\timers.asm
endif
ifndef cyctCutFast
	cyctCutFast = 10
endif
ifndef cyctShowSlow
	cyctShowSlow = 0
endif
ifndef cyctShowDiff
	cyctShowDiff = 0
endif
ifndef cyctShowSize
	cyctShowSize = 1
endif

cyctSleepMs = 	30
cyctShowSize = 	0
.data?
cyctSize	dd ?
cyctStrLen	dd ?
cyctCounter	dd ?, ?, ?, ?, ?
cyctSortTable	dd 1000 dup(?)	; overwrites next dd
cyctTableMode	SDWORD ?
.const

cyct_begin MACRO cyct_lc, cyct_prio	;; both arguments are optional
LOCAL cyct_prioclass, lbl
  ifdef cyctSleepMs
	invoke Sleep, cyctSleepMs
  endif
  ifnb <cyct_lc>
	cyctSubCt = cyct_lc/1000 				;; 1000 entries in cyctSortTable
  else
	cyctSubCt = LOOP_COUNT/1000
  endif
  if cyctSubCt lt 50
  	cyctSubCt = 50
  	; 25 seems to be the minimum for reasonable timings
  endif
  ifnb <cyct_prio>
	cyct_prioclass equ <cyct_prio> 		;; v v default below
  else
	cyct_prioclass equ HIGH_PRIORITY_CLASS
  endif
  ; int 3
  and cyctCounter, 0								;; clear the counter
  mov cyctSize, offset lbl
  .Repeat
	counter_begin cyctSubCt, cyct_prioclass
lbl:	
	
ENDM
; -------------------------------------------------------------------------	mov eax, len(offset Tst50)	; the code in between the two macros ---------------------
cyct_end MACRO arg
LOCAL tmp$, lbl
lbl:
  counter_end
  	mov edx, cyctCounter
  	mov [cyctSortTable+4*edx], eax
	inc cyctCounter
  .Until edx>=sizeof cyctSortTable/4-1
  sub cyctSize, offset lbl
  neg cyctSize
  tmp$ CATSTR <mov eax, chr$(">, <arg>, <",13,10)>
  ;% echo tmp$
  tmp$
  call cyct_endP	;; calculate and show results
ENDM

.code
cyct_endP proc
  push ebp
  push esi
  push ebx
  push eax
  inc edx
  invoke CombSortA, offset cyctSortTable, edx
  xor ebx, ebx
  ; ifline cyctTableMode!<=0, print chr$(13, 10)
  if cyctShowSlow
	print chr$(10)
	.Repeat
  		print str$(ebx), ":"
		mov eax, [cyctSortTable+4*ebx]
		print str$(eax), " "
	  	inc ebx
	.Until ebx>cyctCutFast
	if cyctShowSlow gt 0
		print chr$(13, 10, 10, "...", 13, 10, 10)
		mov ebx, cyctCounter
		sub ebx, cyctShowSlow
		.Repeat
  			print str$(ebx), ":"
			mov eax, [cyctSortTable+4*ebx]
			print str$(eax), " "
  			inc ebx
		.Until ebx>=cyctCounter
	endif
  endif
  pop ebp	; pushed as eax
  if cyctShowDiff
  .if byte ptr [ebp]!="#"
	print chr$(13, 10)
	print ebp
	print chr$(13, 10, "average with cutoff", 9)
  .endif
  endif
  push cyctCutFast
  pop ebx
  mov eax, [cyctSortTable+4*cyctCutFast]		;; determine the cutoff value
  mov esi, eax			; eax is one of the lowest timings
  shr esi, 2			; /4
  inc esi
  add esi, eax			; esi = eax * 1.25 + 1
  xor eax, eax
  .Repeat
	mov ecx, [cyctSortTable+4*ebx]
	inc ebx
	.Break .if ecx>esi
	add eax, ecx
  .Until ebx>cyctCounter
  sub ebx, cyctCutFast+2
  je @F
  cdq
  div ebx
  @@:
  push eax
  .if cyctTableMode
	; printFix cyctColW, str$(eax)		; the actual cycles
  .else
	print str$(eax)
  .endif
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
			print chr$(32, 9, "cutoff at n=")
			add ebx, cyctCutFast+1
			print str$(ebx), " for ", 62		; >n cycles
			print str$(esi), " cycles"
		.else
  			print chr$(32, 9, "no cutoff")
		.endif
		print chr$(13, 10, "average w/o cutoff ", 9)
	else
		.if cyctTableMode==0
			.if ebx<=sizeof cyctSortTable/4-cyctCutFast-1
				add ebx, cyctCutFast+1
				.if ebx<127
					print "*"
				.endif
			.endif
			print chr$(9)
			print ebp
		.endif
	endif
  .endif
  xor eax, eax
  xor ebx, ebx
  mov edx, cyctCounter
  .Repeat
	add eax, [cyctSortTable+4*ebx]
	inc ebx
  .Until ebx>edx
  test eax, eax
  js @F	; something is wrong here
  dec ebx
  je @F	; rare event
  cdq
  div ebx
  @@:
  mov ebx, eax
  .if byte ptr [ebp]!="#"
	if cyctShowDiff
		print str$(eax), 13, 10, "difference raw-cutoff:", 9
		sub ebx, [esp]
		print str$(ebx)
	endif
  .endif
  if cyctShowSize
	print "    ", 9, "codesize="
	print str$(cyctSize), " bytes"
  endif
  pop eax
  pop ebx
  pop esi
  pop ebp
  ret
cyct_endP endp
.const
